

if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("limma")

install.packages("reshape2")
install.packages("ggpubr")


#ð
library(limma)
library(reshape2)
library(ggpubr)

expFile="geneExp.txt"          #ļ
scoreFile="TMEscores.txt"      #΢Ĵļ
setwd("C:\\biowolf\\Gene\\24.TMEvioplot")     #ùĿ¼

#ȡļ
exp=read.table(expFile, header=T, sep="\t", check.names=F, row.names=1)
gene=colnames(exp)[1]
exp=exp[exp$Type=="Tumor",1,drop=F]
exp$Type=ifelse(exp[,gene]>median(exp[,gene]), "High", "Low")

#ȡ΢ļݽ
score=read.table(scoreFile, header=T, sep="\t", check.names=F, row.names=1)
score=score[,1:3]

#Ʒȡ
sameSample=intersect(row.names(exp), row.names(score))
exp=exp[sameSample,"Type",drop=F]
score=score[sameSample,,drop=F]
rt=cbind(score, exp)
rt$Type=factor(rt$Type, levels=c("Low", "High"))

#ϲתΪggplot2ļ
data=melt(rt, id.vars=c("Type"))
colnames(data)=c("Type", "scoreType", "Score")

#Сͼ
p=ggviolin(data, x="scoreType", y="Score", fill = "Type",
	     xlab="",
	     ylab="TME score",
	     legend.title=gene,
	     add = "boxplot", add.params = list(color="white"),
	     palette = c("blue","red"), width=1)
p=p+rotate_x_text(45)
p1=p+stat_compare_means(aes(group=Type),
	      method="wilcox.test",
	      symnum.args=list(cutpoints = c(0, 0.001, 0.01, 0.05, 1), symbols = c("***", "**", "*", " ")),
	      label = "p.signif")

#ͼ
pdf(file="vioplot.pdf", width=6, height=5)
print(p1)
dev.off()


