

install.packages("Seurat")
install.packages("outliers")
install.packages("pbmcapply")
install.packages("doFuture")

if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("singscore")
BiocManager::install("GSVA")
BiocManager::install("GSEABase")
BiocManager::install("limma")

install.packages("devtools")
library(devtools)
devtools::install_github('dviraran/SingleR')



###################################04.ǰڴͽ###################################
#ȡ
library(limma)
library(Seurat)
library(dplyr)
library(magrittr)

setwd("D:\\Scientific Research\\Implementation\\cxcl10\\singelcell\\again")             #ùĿ¼

#ȡļظȡֵ
rt=read.table("geneMatrix.txt",sep="\t",header=T,check.names=F)
rt=as.matrix(rt)
rownames(rt)=rt[,1]
exp=rt[,2:ncol(rt)]
dimnames=list(rownames(exp),colnames(exp))
data=matrix(as.numeric(as.matrix(exp)),nrow=nrow(exp),dimnames=dimnames)
data=avereps(data)

#תΪSeurat󣬲ݽй
pbmc <- CreateSeuratObject(counts = data,project = "seurat", min.cells = 3, min.features = 50, names.delim = "_",)
#ʹPercentageFeatureSetİٷֱ
pbmc[["percent.mt"]] <- PercentageFeatureSet(object = pbmc, pattern = "^MT-")
pdf(file="04.featureViolin.pdf",width=10,height=6)           #Сͼ
VlnPlot(object = pbmc, features = c("nFeature_RNA", "nCount_RNA", "percent.mt"), ncol = 3)
dev.off()
pbmc <- subset(x = pbmc, subset = nFeature_RNA > 50 & percent.mt < 5)    #ݽй

#ȵԻͼ
pdf(file="04.featureCor.pdf",width=10,height=6)              #ͼ
plot1 <- FeatureScatter(object = pbmc, feature1 = "nCount_RNA", feature2 = "percent.mt",pt.size=1.5)
plot2 <- FeatureScatter(object = pbmc, feature1 = "nCount_RNA", feature2 = "nFeature_RNA",,pt.size=1.5)
CombinePlots(plots = list(plot1, plot2))
dev.off()

#ݽб׼
pbmc <- NormalizeData(object = pbmc, normalization.method = "LogNormalize", scale.factor = 10000)
#ȡЩϸϵϴĻ
pbmc <- FindVariableFeatures(object = pbmc, selection.method = "vst", nfeatures = 3000)
#ͼ
top10 <- head(x = VariableFeatures(object = pbmc), 10)
pdf(file="04.featureVar.pdf",width=10,height=6)              #ͼ
plot1 <- VariableFeaturePlot(object = pbmc)
plot2 <- LabelPoints(plot = plot1, points = top10, repel = TRUE)
CombinePlots(plots = list(plot1, plot2))
dev.off()





###################################05.PCAɷַ###################################
##PCA
pbmc=ScaleData(pbmc)                     #PCAά֮ǰı׼Ԥ
pbmc=RunPCA(object= pbmc,npcs = 20,pc.genes=VariableFeatures(object = pbmc))     #PCA

#ÿPCAɷֵػ
pdf(file="05.pcaGene.pdf",width=10,height=8)
VizDimLoadings(object = pbmc, dims = 1:4, reduction = "pca",nfeatures = 20)
dev.off()

#ɷַͼ
pdf(file="05.PCA.pdf",width=6.5,height=6)
DimPlot(object = pbmc, reduction = "pca")
dev.off()

#ɷַͼ
pdf(file="05.pcaHeatmap.pdf",width=10,height=8)
DimHeatmap(object = pbmc, dims = 1:4, cells = 500, balanced = TRUE,nfeatures = 30,ncol=2)
dev.off()

#ÿPCpֲֵ;ȷֲ
pbmc <- JackStraw(object = pbmc, num.replicate = 100)
pbmc <- ScoreJackStraw(object = pbmc, dims = 1:20)
pdf(file="05.pcaJackStraw.pdf",width=8,height=6)
JackStrawPlot(object = pbmc, dims = 1:20)
dev.off()





###################################06.TSNEmarker###################################
##TSNE
pcSelect=15
pbmc <- FindNeighbors(object = pbmc, dims = 1:pcSelect)                #ڽӾ
pbmc <- FindClusters(object = pbmc, resolution = 0.5)                  #ϸ,Ż׼ģ黯
pbmc <- RunTSNE(object = pbmc, dims = 1:pcSelect)                      #TSNE
pdf(file="06.TSNE.pdf",width=6.5,height=6)
TSNEPlot(object = pbmc, do.label = TRUE, pt.size = 2, label = TRUE)    #TSNEӻ
dev.off()
write.table(pbmc$seurat_clusters,file="06.tsneCluster.txt",quote=F,sep="\t",col.names=F)

##ѰҲ
logFCfilter=0.5
adjPvalFilter=0.05
pbmc.markers <- FindAllMarkers(object = pbmc,
                               only.pos = FALSE,
                               min.pct = 0.25,
                               logfc.threshold = logFCfilter)
sig.markers=pbmc.markers[(abs(as.numeric(as.vector(pbmc.markers$avg_logFC)))>logFCfilter & as.numeric(as.vector(pbmc.markers$p_val_adj))<adjPvalFilter),]
write.table(sig.markers,file="06.markers.xls",sep="\t",row.names=F,quote=F)


#markerСͼ
pdf(file="06.markerViolin.pdf",width=10,height=6)
VlnPlot(object = pbmc, features = c("Cxcl10", "Ccl5"))
dev.off()

#markerڸclusterɢͼ
pdf(file="06.markerScatter.pdf",width=10,height=6)
FeaturePlot(object = pbmc, features = c("Cxcl10", "Ccl5"),cols = c("green", "red"))
dev.off()

#markerڸclusterͼ
pdf(file="06.markerBubble.pdf",width=12,height=6)
cluster10Marker=c('Csn2', 'Wap', 'Glycam1', 'Lrg1', 'Clu', 'Bspry', 'Cdca3', 'Pclaf', 'Stc2', 'Tph1', ' Wfdc12', 'Apoe', 'Dcpp1', 'Ccl2','Col6a1',' Igfbp4', 'Htra1', 'Apod', 'Snhg18')
DotPlot(object = pbmc, features = cluster10Marker)
dev.off()





#

